<?php
namespace Controller;

use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource\DataSet;
use Util\InstanceProvider;

class ReplanningReason
{
    public function findReplanningReason(Request\Filter $request, Response $response)
    {
        try {
            $conditions = $request->getFilterCriteria()->getConditions();
            $replanningReasonService = InstanceProvider::getService()->getReplanningReason();
            $replanningReason = $replanningReasonService->findReplanningReason($conditions);
            $response->addDataset(new DataSet('replanningReason', $replanningReason));
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage() . ' Code:' . $e->getCode());
        }
    }
    
    public function saveReplanningReason(Request\DataSet $request, Response $response)
    {
        try {
            $replanningReasonService = InstanceProvider::getService()->getReplanningReason();
            $row = $request->getDataSet()->getRows()[0];
            $id = empty($row['ID']) ? NULL : $row['ID'];
            $description = $row['DESCRIPTION'];
            $status = $row['STATUS'];
            $dataSet = $replanningReasonService->saveReplanningReason($id, $description, $status);
            $response->addDataset(new DataSet('replanningReason', [$dataSet]));
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage() . ' Code:' . $e->getCode());
        }
    }
    
    public function deleteReplanningReason(Request\DataSet $request, Response $response)
    {
        try {
            $replanningReasonService = InstanceProvider::getService()->getReplanningReason();
            $row = $request->getDataSet()->getRows()[0];
            $replanningReasonId = $row['ID'];
            $replanningReasonService->deleteReplanningReason($replanningReasonId);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage() . ' Code:' . $e->getCode());
        }
    }
}