<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 01/08/2016
 * Time: 15:51
 */

namespace Service;

use Doctrine\ORM\EntityManager;
use Zeedhi\DevOps\Model\Projectmanagement\Repositories;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;
use Zeedhi\DevOps\Util\Utilities;

class ClassificationTaskStatus
{

    /** @var Repositories\ClassificationTaskStatus */
    protected $classificationTaskStatusRepository;

    /** @var Repositories\TaskStatus */
    protected $taskStatusRepository;

    /**@var EntityManager */
    private $entityManager;

    /**@var Utilities */
    private $environment;

    /** @var \Factory\ClassificationTaskStatus */
    private $classificationTaskStatusFactory;

    public function __construct(EntityManager $entityManager, \Util\Utilities $environment,
                                \Factory\ClassificationTaskStatus $classificationTaskStatusFactory)
    {

        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->classificationTaskStatusFactory = $classificationTaskStatusFactory;
        $this->classificationTaskStatusRepository = $this->entityManager->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'ClassificationTaskStatus');
        $this->taskStatusRepository = $this->entityManager->getRepository(Utilities::PROJECT_MANAGEMENT_ENTITY_DIR . 'TaskStatus');
    }

    public function saveArrayTaskStatus($classification, array $arrayTaskStatus, $type)
    {
        foreach ($arrayTaskStatus as $taskStatus) {
            if (!empty($taskStatus)) {
                $classificationTaskStatus = $this->classificationTaskStatusRepository->findOneBy(
                    array('taskStatus' => $taskStatus,'classification' => $classification, 'type' => $type));
                if (empty($classificationTaskStatus)) {
                    $this->createClassificationTaskStatus($classification, $taskStatus, $type);
                }
            }
        }

        $this->entityManager->flush();
        /** @var Entities\ClassificationTaskStatus[] $arrayClassificationTaskStatus */
        $arrayClassificationTaskStatus = $this->classificationTaskStatusRepository->findBy(
            array('classification' => $classification, 'type' => $type));
        $arrayTaskStatusId = Utilities::getArrayByArrayObjectWithGet($arrayTaskStatus);
        foreach ($arrayClassificationTaskStatus as $classificationTaskStatus) {
            if (!in_array($classificationTaskStatus->getTaskStatus()->getId(), $arrayTaskStatusId)) {
                $this->entityManager->remove($classificationTaskStatus);
            }
        }
        $this->entityManager->flush();
    }

    public function saveArrayAllowedTaskStatusId($classification, array $taskStatusIds)
    {
        $taskStatus = array();
        foreach ($taskStatusIds as $taskStatusId) {
            $taskStatus[] = $this->taskStatusRepository->find($taskStatusId);
        }
        $this->saveArrayTaskStatus($classification, $taskStatus, Entities\ClassificationTaskStatus::ALLOWED_TYPE);
    }

    public function saveArrayNotAllowedTaskStatusId($classification, array $taskStatusIds)
    {
        $taskStatus = array();
        foreach ($taskStatusIds as $taskStatusId) {
            $taskStatus[] = $this->taskStatusRepository->find($taskStatusId);
        }
        $this->saveArrayTaskStatus($classification, $taskStatus, Entities\ClassificationTaskStatus::NOT_ALLOWED_TYPE);
    }

    public function createClassificationTaskStatus(Entities\Classification $classification, Entities\TaskStatus $taskStatus, $type)
    {
        $classificationTaskStatus = $this->classificationTaskStatusFactory->createClassificationTaskStatus($classification,
            $taskStatus, $type);
        $this->entityManager->persist($classificationTaskStatus);
    }

    public function deleteClassificationTaskStatus(Entities\Classification $classification)
    {
        $classificationTaskStatuses = $this->classificationTaskStatusRepository->findBy(array('classification' => $classification));
        foreach ($classificationTaskStatuses as $classificationTaskStatus) {
            $this->entityManager->remove($classificationTaskStatus);
        }
        $this->entityManager->flush();
    }
} 