<?php
namespace Zeedhi\Tools\DatabaseReader\DTO;

class Column {

    // oracle lob
    const DATA_TYPE_BINARY   = 'L'; // l is for Lob
    const DATA_TYPE_CLOB     = 'C'; // C is for CLob
    // oracle char(1) Y/N
    const DATA_TYPE_BOOLEAN  = 'B';
    // oracle date
    const DATA_TYPE_DATE     = 'D';
    // oracle datetime
    const DATA_TYPE_DATETIME = 'T';
    // oracle float()
    const DATA_TYPE_FLOAT    = 'F';
    // oracle numeric
    const DATA_TYPE_INTEGER  = 'I';
    // oracle varchar2
    const DATA_TYPE_STRING   = 'S';
    // ORACLE CHAR
    const DATA_TYPE_STRING_FIXED   = 'H';

    /** @var string */
    protected $name;
    /** @var string */
    protected $dataType;
    /** @var int */
    protected $dataLength;
    /** @var int */
    protected $dataPrecision;
    /** @var int */
    protected $dataScale;
    /** @var bool */
    protected $nullAble;
    /** @var string */
    protected $dataDefault;
    /** @var Table */
    protected $table;

    /**
     * @param mixed $dataDefault
     */
    public function setDataDefault($dataDefault)
    {
        $this->dataDefault = $dataDefault;
    }

    /**
     * @return mixed
     */
    public function getDataDefault()
    {
        return $this->dataDefault;
    }

    /**
     * @param mixed $dataLength
     */
    public function setDataLength($dataLength)
    {
        $this->dataLength = $dataLength;
    }

    /**
     * @return mixed
     */
    public function getDataLength()
    {
        return $this->dataLength;
    }

    /**
     * @param mixed $dataPrecision
     */
    public function setDataPrecision($dataPrecision)
    {
        $this->dataPrecision = $dataPrecision;
    }

    /**
     * @return mixed
     */
    public function getDataPrecision()
    {
        return $this->dataPrecision;
    }

    /**
     * @param mixed $dataScale
     */
    public function setDataScale($dataScale)
    {
        $this->dataScale = $dataScale;
    }

    /**
     * @return mixed
     */
    public function getDataScale()
    {
        return $this->dataScale;
    }

    /**
     * @param mixed $dataType
     */
    public function setDataType($dataType)
    {
        $this->dataType = $dataType;
    }

    /**
     * @return mixed
     */
    public function getDataType()
    {
        return $this->dataType;
    }

    /**
     * @param mixed $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * @return mixed
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @param mixed $nullAble
     */
    public function setNullAble($nullAble)
    {
        $this->nullAble = $nullAble;
    }

    /**
     * @return mixed
     */
    public function getNullAble()
    {
        return $this->nullAble;
    }

    public function setTable($table){
        $this->table = $table;
    }

    public function getTable(){
        return $this->table;
    }
}