<?php
namespace Zeedhi\Tools\DatabaseReader\DTO;

class Constraint {

    const CONSTRAINT_TYPE_PK = 'P';
    const CONSTRAINT_TYPE_FK = 'F';
    const CONSTRAINT_TYPE_UNIQUE = 'U';
    const CONSTRAINT_TYPE_CHECK = 'C';

    const IS_REAL = 'Y';

    const DELETE_RULE_CASCADE = 'C';
    const DELETE_RULE_RESTRICT = 'R';
    const DELETE_RULE_SET_NULL = 'S';
    const DELETE_RULE_NO_ACTION = 'N';


    /** @var string */
    protected $constraintName;
    /** @var Table */
    protected $table;
    /** @var Constraints\ConsColumn[] */
    protected $consColumns = [];

    protected $type;

    /**
     * @param string $constraintName
     */
    public function __construct($constraintName) {
        $this->constraintName = $constraintName;
    }

    /**
     * @param Constraints\ConsColumn $consColumn
     */
    public function setConsColumn(Constraints\ConsColumn $consColumn) {
        $this->consColumns[] = $consColumn;
    }

    /**
     * @return string
     */
    public function getConstraintName()
    {
        return $this->constraintName;
    }

    /**
     * @return Constraints\ConsColumn
     */
    public function getConsColumns() {
        return $this->consColumns;
    }

    public function setTable($table) {
        $this->table = $table;
    }

    public function getTable() {
        return $this->table;
    }

    public function setConstraintType($type) {
        $this->type = $type;
    }

    public function getConstraintType() {
        return $this->type;
    }
}